﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Camera2D
{
    class Camera2D
    {
    protected float zoom; // Camera Zoom
    public Matrix   transform; // Matrix Transform
    public Vector2  pos; // Camera Position
    protected float rotation; // Camera Rotation
 
    public Camera2D()
        {
        zoom = 1.0f;
        rotation = 0.0f;
        pos = Vector2.Zero;
        }

    public float Zoom
        {
        get { return zoom; }
        set { zoom = value;if (zoom < 0.02f) zoom = 0.02f; } // Negative zoom will flip image}
        }

    public float Rotation
        {
        get { return rotation; }
        set { rotation = value; }
        }

    
    public void Move(Vector2 amount)
        {
        pos += amount;
        }
    
    public Vector2 Pos
        {
        get { return pos; }
        set { pos = value; }
        }

    public Matrix get_transformation(GraphicsDevice graphicsDevice)
        {    
        transform = Matrix.CreateTranslation(new Vector3(-pos.X, -pos.Y, 0)) *
                    Matrix.CreateRotationZ(Rotation) *
                    Matrix.CreateScale(new Vector3(Zoom, Zoom, 1)) *
                    Matrix.CreateTranslation(new Vector3(graphicsDevice.Viewport.Width * 0.5f, graphicsDevice.Viewport.Height * 0.5f, 0));
        return transform;
        }
    }
}
